/************************************************************************
 *									*
 *		`bdr@r^f@botvO			*
 *									*
 *				: PO荞ݏ		*
 *		t@C	: int10ms.c				*
 *									*
 ************************************************************************/

#pragma	SECTION	PROG=int10ms

#include "sg_cpu.h"

/*	֐	*/
static	void	tmc_mbibit(void);
static	void	tmc_dustart(void);
static	void	tmc_update(void);
static	void	tmc_dudata(void);
static	void	tmc_duchar(void);
static	void	tmc_digital(void);
static	void	tmc_ibit(void);
static	void	tmc_gscbackup(void);
static	void	tmc_simulation(void);

/*=======================================================================
 |
 |		PO荞ݏ
 |
 |	void	int10ms()
 |
 =======================================================================*/
#pragma	INTERRUPT
void	int10ms(void)
{
//	tmc_mbibit();	/* lah{[hahsI荞݃^CAEgo */
	tmc_dustart();	/* c^tオ茟o */
	tmc_update();	/* f[^XV̊Ď */
	tmc_dudata();	/* c^tփf[^Myуf[^MĎ */
	tmc_duchar();	/* c^t̃f[^̕ԃ^CAEgo */
	tmc_digital();	/* fW^\̍XV^C~ÕJEg */
	tmc_ibit();	/* h|ahs^C}[ */
	tmc_gscbackup();/* frb`I荞ݒ~̃obNAbv */
	tmc_simulation();/* fobOp̓f[^V~[V */
}
#pragma	INTERRUPT-

/*=======================================================================
 |
 |		lah{[hahsI荞݃^CAEgo
 |
 |	void	tmc_mbibit()
 |
 =======================================================================*/
static	void	tmc_mbibit(void)
{
	if (tm_mbibit != TM_STOP) {
		if (--tm_mbibit == 0) {
			if (++counter_mbibit < 3)
				mbibit();/* lah{[hahs`FbNĎs */
			else {
/*@@@@@@@@@@@*/
extern	short	test_mbi_error;
test_mbi_error = 1;
/*@@@@@@@@@@@*/
//				halt_cpu("MBI BIT ERROR", 1);
			}
		}
	}
}

/*=======================================================================
 |
 |		c^tオ茟o
 |
 |	void	tmc_dustart()
 |
 =======================================================================*/
static	void	tmc_dustart(void)
{
	if (tm_dustart != TM_STOP) {
		if (--tm_dustart == 0) {	/* ROb */
			sg_mode = SGM_NORMAL;
			sg_bit_status |= BIT_SG_232T;
		}
	}
}

/*=======================================================================
 |
 |		f[^XV̊Ď
 |
 |	void	tmc_update()
 |
 =======================================================================*/
static	void	tmc_update(void)
{
	if (tm_update != TM_STOP) {
		if (--tm_update == 0) {		/* Pb */
			/* PTTRaf[^XV[gۑ */
			rate_1553B = count_1553B;

			/* PTTRaf[^MJE^NA */
			count_1553B = 0;

			/* atr e`hk`FbN */
			if ((debug_flag & DBF_1553B) == 0) {
				if (rate_1553B == 0) {
					if (bus_fail == 0) {
						if (++count_nodata == 5)
							bus_fail = 1;
					}
				} else {
					count_nodata = 0;
					bus_fail = 0;
				}
			}

			/* \XV[gۑ */
			rate_gscint = count_gscint;

			/* \XVJE^NA */
			count_gscint = 0;

			/* ^C}[ăZbg */
			tm_update = TM_UPDATE;
		}
	}
}

/*=======================================================================
 |
 |		c^tփf[^Myуf[^MĎ
 |
 |	void	tmc_dudata()
 |
 =======================================================================*/
static	void	tmc_dudata(void)
{
	if (tm_dudata != TM_STOP) {
		if (--tm_dudata == 0) {
			/* f[^M`FbN */
			if (du_rcvflag == 0) {
				if (sg_mode != SGM_PBIT)
					sg_bit_status |= BIT_SG_232T;

				/* ct`qs */
				if (debug_mode != DBM_VT)
					set_DUART();
			} else
				sg_bit_status &= ~BIT_SG_232T;

			/* Mobt@NA */
			SET_WORD(du_send_data, 0, 3);

			/* MĎ^C}[Zbg */
			tm_dudata = TM_DUDATA;

			switch (sg_mode) {
			case SGM_IBIT:
				switch (ibit_mode) {
				case IBIT_START:
					du_send_data[5] |= 0x01;
					ibit_status(BIT_OK);
					tm_dudata = TM_DUIBIT;
					break;
				case IBIT_DUBIT:
					ibit_status(BIT_NG);
					break;
				}
				break;
			case SGM_RBIT:
				if ((rbit_mode & RBIT_DUBIT) == 0) {
					du_send_data[5] |= 0x02;
					tm_dudata = TM_DURBIT;
					rbit_mode |= RBIT_DUBIT;
				} else {
					rbit_mode |= RBIT_DU_END;
				}
				if ((rbit_mode & (RBIT_SG_END | RBIT_DU_END))
						== (RBIT_SG_END | RBIT_DU_END))
					sg_mode = SGM_NORMAL;
				break;
			case SGM_NORMAL:
				switch (echo_mode) {
				case ECHO_START:
					du_send_data[4] |= 0x80;
					echo_mode = ECHO_WAIT;
					break;
				case ECHO_WAIT:
					echo_status = ECHO_NG;
					echo_mode = ECHO_END;
					break;
				}
				break;
			}

			/* f[^M */
			rsa_send(du_send_data, 6);

			du_rcvflag = 0;
		}
	}
}

/*=======================================================================
 |
 |		c^t̃f[^̕ԃ^CAEgo
 |
 |	void	tmc_duchar()
 |
 =======================================================================*/
static	void	tmc_duchar(void)
{
	if (tm_duchar != TM_STOP) {
		if (--tm_duchar == 0) {
			rsa_rcvcounter = 0;	/* Mf[^̂Ă */
		}
	}
}

/*=======================================================================
 |
 |		fW^\̍XV^C~ÕJEg
 |
 |	void	tmc_digital()
 |
 =======================================================================*/
static	void	tmc_digital(void)
{
	if (tm_digital != TM_STOP) {
		if (--tm_digital == 0) {
			/* fW^\XVtOZbg */
			digital_update_flag = 1;

			/* fW^\XV^C}[ăZbg */
			tm_digital = TM_DIGITAL;
		}
	}
}

/*=======================================================================
 |
 |		h|ahs^C}[
 |
 |	void	tmc_ibit()
 |
 =======================================================================*/
static	void	tmc_ibit(void)
{
	if (tm_ibit != TM_STOP) {
		if (--tm_ibit == 0) {
			switch (ibit_mode) {
			case IBIT_TPTN1:
			case IBIT_TPTN2:
			case IBIT_TPTN3:
			case IBIT_TPTN4:
				ibit_status(BIT_OK);
				break;
			case IBIT_SWITCH:
				sg_bit_status |= BIT_SG_SW;
				ibit_status(BIT_NG);
				break;
			case IBIT_RESULT:
				break;
			}
		}
	}
}

/*=======================================================================
 |
 |		frb`I荞ݒ~̃obNAbv
 |
 |	void	tmc_gscbackup()
 |
 =======================================================================*/
static	void	tmc_gscbackup(void)
{
	if (tm_gscbackup != TM_STOP) {
		if (--tm_gscbackup == 0) {
			/* c^oq`oɃZbg */
			*(DP *)GSC_RAP_DP = dp_tmp;

			/* o^`rbgq`oɃZbg */
			COPY_WORD(GSC_RAP_PA, pa_tmp, N_PABIT);

			/* vZJntOZbg */
			calc_flag = 1;

			/* frb{[hُ */
			gsc_board_test = BIT_NG;

			tm_gscbackup = TM_GSCBACKUP;
		}
	}
}

/*=======================================================================
 |
 |		fobOp̓f[^V~[V
 |
 |	void	tmc_simulation()
 |
 =======================================================================*/
static	void	tmc_simulation(void)
{
	if (tm_simulation != TM_STOP) {
		if (--tm_simulation == 0) {
			debug_simulation();
			tm_simulation = TM_SIMULATION;
		}
	}
}
